#-------------------------------------------------------------------------------------------
#
#	Program:	< DMZ 1.5 >
#	File:		< dmz.make >
#	
#	by Pete Helme
#	of <Apple Macintosh Developer Technical Support - or wheverever>
#
#	Modification History
#	9/15/95  rrk	verified compatibility with OT 1.1b3
#	7/30/95	 rrk 	completed changes for OT 1.0.5b4 - updated for use with ETO 17
#	7/30/94	 rrk 	Implemented changed to use Open Transport
#	5/23/94	 rrk	Implemented changes for compatibility with PPC
#	
#	Note: This make file assumes that the OpenTransport headers are in the folder "OTIncludes" in the 
#			MPW Interfaces folder.
#		  You will also need to specify a define for OTLibraries
#-------------------------------------------------------------------------------------------

OTIncludesDir	=	{MPW}Interfaces:OTIncludes
Sources			=	:sources
Objects			= 	:objects

PPC				=	PPCC -w conformance -appleext on

SymOptions		=	-sym full

OptOptions		=	-opt off

IncludeFolders	= 	-i "{OTIncludesDir}"

PPCOptions		=	{IncludeFolders} {SymOptions} {OptOptions}


COptions		= {SymOptions} {IncludeFolders}

AOptions		= {SymOptions}

LinkOptions 	= {SymOptions} -w

CObjs			=	"{Objects}":dmzMain.c.o 
					"{Objects}":dmzLists.c.o 
					"{Objects}":dmzAT.c.o 
					"{Objects}":OpenTptUtilities.c.o 
					"{Objects}":SpinCursor.c.o 
					"{Objects}":dmzOT.c.o
					
CSysObjs		= 	"{Libraries}"MacRuntime.o 
					"{CLibraries}"StdCLib.o 
					"{Libraries}"IntEnv.o 
					"{Libraries}"ToolLibs.o 
					"{Libraries}"Interface.o

OTObjs			=	"{OTLibraries}"OpenTransport.n.o 
					"{OTLibraries}"OpenTransportApp.n.o 
					"{OTLibraries}"OpenTptATalk.n.o
	
PPCObjs			=	"{Objects}":dmzMain.o 
					"{Objects}":dmzLists.o 
					"{Objects}":dmzAT.o 
					"{Objects}":OpenTptUtilities.o 
					"{Objects}":SpinCursor.o 
					"{Objects}":dmzOT.o

PPCSysObjs		=	"{SharedLibraries}"InterfaceLib 
					"{SharedLibraries}"StdCLib 
					"{PPCLibraries}"MathLib.xcoff 
					"{PPCLibraries}"StdCRuntime.o 
					"{PPCLibraries}"PPCCRuntime.o 
					"{PPCLibraries}"PPCToolLibs.o 
					-librename MathLib.xcoff=MathLib

PPCOTObjs		= 	"{OTLibraries}"OpenTransportLib 
					"{OTLibraries}"OpenTptAppleTalkLib 
					"{OTLibraries}"OpenTransportAppPPC.o 
					"{OTLibraries}"OpenTptATalkPPC.o


CLDEFObjs		=	"{Objects}":dmzLDEF.c.o 
					"{Libraries}"Interface.o

dmz			{CLDEFObjs} dmz.make
		Link -m MAIN -rt LDEF=128 -ra Main=resLocked -o "{Objects}":dmzLDEF.rsrc {CLDEFObjs}
		DeRez "{Objects}":dmzLDEF.rsrc > "{Sources}":dmzLDEF.r
		Rez "{Sources}":dmzLDEF.r -rd -o {Targ} -append
	
dmz			{CObjs} dmz.make "{Sources}":SktListener.rsrc "{Sources}":dmz.r
			Link {LinkOptions} {CObjs} {CSysObjs} {OTObjs} -o {Targ} 
			Rez "{Sources}":dmz.r -append -o dmz -s "{Objects}"
			SetFile {Targ} -t APPL -c 'MOOS' -a B

"{Objects}":dmzLDEF.c.o  "{Sources}":dmzLDEF.c
			SC {COptions} "{Sources}":dmzLDEF.c -o "{Objects}":dmzLDEF.c.o
	
"{Objects}":dmzAT.c.o  "{Sources}":dmzAT.c "{Sources}":dmz.h
			SC {COptions} "{Sources}":dmzAT.c -o "{Objects}":dmzAT.c.o
	
"{Objects}":dmzOT.c.o  "{Sources}":dmzOT.c "{Sources}":dmz.h
			SC {COptions} "{Sources}":dmzOT.c -o "{Objects}":dmzOT.c.o
	
"{Objects}":dmzLists.c.o  "{Sources}":dmzLists.c "{Sources}":dmz.h
			SC {COptions} "{Sources}":dmzLists.c -o "{Objects}":dmzLists.c.o

"{Objects}":dmzMain.c.o  "{Sources}":dmzMain.c "{Sources}":dmz.h
			SC {COptions} "{Sources}":dmzMain.c -o "{Objects}":dmzMain.c.o

"{Objects}":OpenTptUtilities.c.o  "{Sources}":OpenTptUtilities.c "{Sources}":dmz.h
			SC {COptions} "{Sources}":OpenTptUtilities.c -o "{Objects}":OpenTptUtilities.c.o
			
"{Objects}":SpinCursor.c.o  "{Sources}":SpinCursor.c "{Sources}":dmz.h
			SC {COptions} "{Sources}":SpinCursor.c -o "{Objects}":SpinCursor.c.o


#"{Objects}":SktListener.rsrc  "{Objects}":SktListener.a.o dmz.make
#				link -o "{Objects}":SktListener.rsrc -t rsrc -c RSED 
#				"{Objects}":SktListener.a.o -rt Sock=128 
#				-m THE_LISTENER -ra locked
				
#"{Objects}":SktListener.a.o  "{Sources}":SktListener.a dmz.make
#			asm {AOptions} "{Sources}":SktListener.a -o "{Objects}":SktListener.a.o
		

dmz			{PPCObjs} dmz.make
		PPCLink {PPCObjs} 
		{PPCSysObjs} 
		{PPCOTObjs} 
		{SymOptions} -w 
		-main __start 
		-o dmz
				
		# Set file's creator type, turn on bundle bit, turn off inited bit
		SetFile dmz -t APPL -c 'MOOS' -a Bi

"{Objects}":dmzAT.o  "{Sources}":dmzAT.c "{Sources}":dmz.h
	{PPC} {PPCOptions} "{Sources}":dmzAT.c -o "{Objects}":dmzAT.o
	
"{Objects}":dmzOT.o  "{Sources}":dmzOT.c "{Sources}":dmz.h
	{PPC} {PPCOptions} "{Sources}":dmzOT.c -o "{Objects}":dmzOT.o
	
"{Objects}":dmzLists.o  "{Sources}":dmzLists.c "{Sources}":dmz.h
	{PPC} {PPCOptions} "{Sources}":dmzLists.c -o "{Objects}":dmzLists.o

"{Objects}":dmzMain.o  "{Sources}":dmzMain.c "{Sources}":dmz.h
	{PPC} {PPCOptions} "{Sources}":dmzMain.c -o "{Objects}":dmzMain.o

"{Objects}":OpenTptUtilities.o  "{Sources}":OpenTptUtilities.c "{Sources}":dmz.h
	{PPC} {PPCOptions} "{Sources}":OpenTptUtilities.c -o "{Objects}":OpenTptUtilities.o

"{Objects}":SpinCursor.o  "{Sources}":SpinCursor.c "{Sources}":dmz.h
	{PPC} {PPCOptions} "{Sources}":SpinCursor.c -o "{Objects}":SpinCursor.o
