/*
	File: SpinCursor.h
	By: Nitin Ganatra.
	Modifications by Rich Kubota
*/

#ifndef __SPINCURSOR__
#define __SPINCURSOR__

#include <Types.h>
#include <Quickdraw.h>
#include <Resources.h>
#include <Events.h>
#include <ToolUtils.h>

#if powerc
#pragma options align=mac68k
#endif

// defines for the spin cursor
#define kDontSpinCursor		-1L
#define kSpinEvery5Ticks	5
#define kDelay30Ticks		30

/* Redefine HiWord() as a macro to increase speed. */
#define HiWrd(aLong)	(((aLong) >> 16) & 0xFFFF)

typedef struct										/* The structure of an 'acur' resource */
{
	short numberOfFrames;							/* number of cursors to animate */
	short whichFrame;									/* current frame number */
	CursHandle frame[1];							/* Pointer to the first cursor */
} animatedCursor, *animatedCursorPtr, **animatedCursorHandle;

extern Boolean 		InitAnimatedCursors(short acurID);
extern void 		StartAnimatedCursors(short interval, short deferral);
extern void 		StopAnimatedCursors(void);
extern void			ReleaseAnimatedCursors(void);
extern void 		SpinTheCursor(void);

#if powerc
#pragma options align=reset
#endif

#endif 	// __SPINCURSOR__