/*
	File:		SNMPtypes.r

	Contains:	SNMP resource type declarations

	Copyright:	 1992 by Apple Computer, Inc., all rights reserved.

*/

/* ---------------------------------------------------------------------------------------------- */
/* --------------------------------- Define Resource types here --------------------------------- */
/* ---------------------------------------------------------------------------------------------- */
#include "Types.r"
#include "Systypes.r"
#include "SNMPVarTypes.h"


/******************************************************************************
	Variable Description Resource.
	
	This resource is used to contain the information about the variables
	to be registered.  
	
	Included in this resource is the resource id of the STR# resources which
	contain the name strings and the description strings for the agent and
	all of the variables. The data for each variable included in this resource
	also contains the index into the name and description string resources.
*******************************************************************************/

type 'vard' {
	unsigned integer;							/* Name resource id      		*/
	unsigned integer;							/* Desc resource id      		*/
	unsigned integer;							/* Index of agent's desc string */
	
	
	unsigned integer = $$CountOf(grouparray); 		/* Group array size	     		 	*/
	wide array grouparray {
		unsigned integer;							/* index for group's strings      	*/
		unsigned integer = $$CountOf(G_OIDarray); 	/* OID array size	      			*/
		wide array G_OIDarray {
			unsigned longint;						/* Object id                   		*/
		};
	}; 		
	
	
	unsigned integer = $$CountOf(Var); 			 	/* Variable array size		*/
	wide array Var {
		integer;									 /* index for Var strings  	*/
		unsigned longint;							 /* ASNTagType			 	*/
		unsigned integer;							 /* SMI Access  (size ??)   */
		integer;									 /* user data 1			    */
		integer;									 /* user data 2  			*/
		longint;									 /* user data 3				*/
		unsigned integer = $$CountOf(IVar_OIDarray); /* OID array size	        */
		wide array IVar_OIDarray {
			unsigned longint;						 /* Object id               */
		};
	}; 

};

